﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CASE_181893
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<TestData> testData = null;
        public MainWindow()
        {
            InitializeComponent();

            testData = new ObservableCollection<TestData>();

            testData.Add(new TestData { Id = 1, Test1 = 1, IsOnChart = true });
            testData.Add(new TestData { Id = 2, Test1 = 34.555, IsOnChart = false});
            testData.Add(new TestData { Id = 3, Test1 = 56, IsOnChart = false });
            testData.Add(new TestData { Id = 4, Test1 = 23, IsOnChart = true });

            this.DataContext = testData;

            Style _DataRecordPresenterStyle = new Style(typeof(DataRecordPresenter));
            _DataRecordPresenterStyle.Setters.Add(new Setter(DataRecordPresenter.OpacityProperty, 1.0));
            var _DataTrigger = new DataTrigger() { Binding = new Binding("DataItem.IsOnChart"), Value = true };
            _DataTrigger.Setters.Add(new Setter(DataRecordPresenter.OpacityProperty, 1.0));
            _DataRecordPresenterStyle.Triggers.Add(_DataTrigger);
            _DataTrigger = new DataTrigger() { Binding = new Binding("DataItem.IsOnChart"), Value = false };
            _DataTrigger.Setters.Add(new Setter(DataRecordPresenter.OpacityProperty, 0.5));
            _DataRecordPresenterStyle.Triggers.Add(_DataTrigger);
            _Grid.FieldLayoutSettings.DataRecordPresenterStyle = _DataRecordPresenterStyle;
        }
    }

    public class TestData : INotifyPropertyChanged
    {
        private int m_id;
        public int Id
        {
            get { return m_id; }
            set
            {
                m_id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private double m_test1;
        public double Test1
        {
            get { return m_test1; }
            set
            {
                m_test1 = value;
                NotifyPropertyChanged("Test1");
            }
        }

        private bool m_isOnChart;
        public bool IsOnChart
        {
            get { return m_isOnChart; }
            set
            {
                m_isOnChart = value;
                NotifyPropertyChanged("IsOnChart");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
